=== debian/changelog ===
gnudatalanguage (0.9.9-12build1) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Jan 2020 05:41:34 +0000

gnudatalanguage (0.9.9-12) unstable; urgency=low

  * Re-add myself to Uploaders.
  * d/control: Add support for GLPK.
  * Add fdo desktop file and icon.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Wed, 09 Oct 2019 10:25:22 +0200

gnudatalanguage (0.9.9-11) unstable; urgency=medium

  [ Axel Beckert ]
  * Switch wxWidgets from GTK 2 to GTK 3. (Closes: #934099)

  [ Ole Streicher ]
  * Build-depend on libeccodes-dev instead of libgrib_api-dev (Closes: #939380)
  * Add gitlab-ci.yml for salsa
  * Push Standardss-Version to 4.4.0. No changes needed.
  * Push compat to 12. Remove d/compat
  * Provide CFLAGS etc. to test helper compilation
  * Fix Python 3 support
  * Add test_total to xfail tests: may require too much memory

 -- Ole Streicher <olebole@debian.org>  Sun, 15 Sep 2019 13:05:28 +0200

gnudatalanguage (0.9.9-10) unstable; urgency=medium

  * Initialize GraphicsMagick on library load (Closes: #927307)

 -- Ole Streicher <olebole@debian.org>  Tue, 23 Apr 2019 13:43:56 +0200

gnudatalanguage (0.9.9-9) unstable; urgency=medium

  * Skip TEST_L64 test (Closes: #923437)

 -- Ole Streicher <olebole@debian.org>  Thu, 28 Feb 2019 14:07:04 +0100

gnudatalanguage (0.9.9-8) unstable; urgency=medium

  * Switch to Python 3

 -- Ole Streicher <olebole@debian.org>  Thu, 10 Jan 2019 16:44:15 +0100

gnudatalanguage (0.9.9-7) unstable; urgency=medium

  * Disable more long-running tests
  * Update d/copyright for new code

 -- Ole Streicher <olebole@debian.org>  Thu, 10 Jan 2019 11:37:33 +0100

gnudatalanguage (0.9.9-6) unstable; urgency=medium

  * Remove tests that take too long on some archs

 -- Ole Streicher <olebole@debian.org>  Wed, 09 Jan 2019 09:40:36 +0100

gnudatalanguage (0.9.9-5) unstable; urgency=medium

  * Switch off altivec on more places
  * Disable tests that may take too long on arm64

 -- Ole Streicher <olebole@debian.org>  Tue, 08 Jan 2019 20:40:29 +0100

gnudatalanguage (0.9.9-4) unstable; urgency=medium

  * Fix ppc64el FTBS fix

 -- Ole Streicher <olebole@debian.org>  Tue, 08 Jan 2019 15:18:18 +0100

gnudatalanguage (0.9.9-3) unstable; urgency=medium

  * Disable specialized code that causes problems on powerpc
  * Handle python/numpy dependencies
  * Remove unused lintuian override

 -- Ole Streicher <olebole@debian.org>  Tue, 08 Jan 2019 13:39:35 +0100

gnudatalanguage (0.9.9-2) unstable; urgency=medium

  * Add some known failing tests to ignore
  * Drop unneeded using namespace std that conflicts with ALTIVEC vector
  * Temporarily disable HDF-5 support. Closes: #915207
  * Push Standards-Version to 4.3.0. No changes needed.

 -- Ole Streicher <olebole@debian.org>  Wed, 02 Jan 2019 16:02:15 +0100

gnudatalanguage (0.9.9-1) unstable; urgency=medium

  * Switch upstream repository to github
  * New upstream version 0.9.9. Rediff patches. Closes: #915207
  * Push Standards-Version to 4.2.1. No changes needed
  * Add new build dependency libgeotiff-dev

 -- Ole Streicher <olebole@debian.org>  Sat, 01 Dec 2018 20:30:14 +0100

gnudatalanguage (0.9.8-7) unstable; urgency=low

  * Disable test_matrix_multiply which takes too long on MIPS

 -- Ole Streicher <olebole@debian.org>  Wed, 30 May 2018 08:49:01 -0700

gnudatalanguage (0.9.8-6) unstable; urgency=low

  * Add numpy to Python test dependencies
  * Update failing tests

 -- Ole Streicher <olebole@debian.org>  Tue, 29 May 2018 09:56:50 -0700
