=== debian/control ===
Source: gnudatalanguage
Maintainer: Debian Astronomy Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Ole Streicher <olebole@debian.org>,
           Axel Beckert <abe@debian.org>,
           Gürkan Myczko <gurkan@phys.ethz.ch>
Section: interpreters
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 12),
               dh-python,
               dpkg-dev (>= 1.16.1~),
               libantlr-dev,
               libeigen3-dev (>= 3.2.4),
               libeigen3-dev (>= 3.3~alpha1-3) [arm64],
               libfftw3-dev,
               libgeotiff-dev,
               libgraphicsmagick++1-dev,
               libeccodes-dev,
               libgsl-dev,
               libhdf4-alt-dev,
               libhdf5-dev,
               libproj-dev,
               libglpk-dev,
               libncurses-dev,
               libnetcdf-dev,
               libplplot-dev (>= 5.13.0+dfsg-~),
               libqhull-dev,
               libreadline-dev,
               libudunits2-dev,
               libwxgtk3.0-gtk3-dev,
               plplot-driver-xwin,
               pslib-dev,
               python3-dev,
               python3-numpy,
               xauth,
               xvfb,
               zlib1g-dev
Standards-Version: 4.4.0
Homepage: https://github.com/gnudatalanguage/gdl
Vcs-Git: https://salsa.debian.org/debian-astro-team/gnudatalanguage.git
Vcs-Browser: https://salsa.debian.org/debian-astro-team/gnudatalanguage
Rules-Requires-Root: no

Package: libgnudatalanguage0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: gnudatalanguage (<< 0.9.5-7~)
Replaces: gnudatalanguage (<< 0.9.5-7~)
Description: Free IDL compatible incremental compiler shared library
 GNU Data Language (GDL) is a free IDL (Interactive Data Language)
 compatible incremental compiler. It has full syntax compatibility
 with IDL 7.1. IDL is a registered trademark of ITT Visual Information
 Solutions.
 .
 This package contains the shared library which is used by the different
 frontends (gdl binary, Python package).

Package: gnudatalanguage
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: plplot-driver-xwin,
            python3-numpy
Description: Free IDL compatible incremental compiler
 GNU Data Language (GDL) is a free IDL (Interactive Data Language)
 compatible incremental compiler. It has full syntax compatibility
 with IDL 7.1. IDL is a registered trademark of ITT Visual Information
 Solutions. From IDL 8.0, the following language elements are
 supported:
 .
  * FOREACH loop
  * negative array indices
  * garbage collection pointers and objects
  * call methods on an object using "." (e. g. `object.aMemberProcedure,arg1`)
 .
 The file input output system is fully implemented. GUI support (widgets) is
 officially provided, but it's not complete yet.
 .
 This package contains the main commandline and interpreter frontend.

Package: python3-gdl
Architecture: any
Multi-Arch: same
Section: python
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Provides: ${python3:Provides}
Recommends: plplot-driver-xwin
Description: Python interface for the GNU Data Language
 GNU Data Language (GDL) is a free IDL (Interactive Data Language)
 compatible incremental compiler. It has full syntax compatibility
 with IDL 7.1. IDL is a registered trademark of ITT Visual Information
 Solutions. From IDL 8.0, the following language elements are
 supported:
 .
  * FOREACH loop
  * negative array indices
  * garbage collection pointers and objects
  * call methods on an object using "." (e. g. `object.aMemberProcedure,arg1`)
 .
 The file input output system is fully implemented. GUI support (widgets) is
 officially provided, but it's not complete yet.
 .
 This package contains the Python library/interface.
