=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%gnudatalanguage-$1.tar.gz%" \
  https://github.com/gnudatalanguage/gdl/tags \
  (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
