=== debian/changelog ===
gnudatalanguage (1.0.0-4) unstable; urgency=medium

  [ Adrian Bunk ]
  * Revert "Use -fcommon to fix ftbfs on ARM"
  * Use -Wl,--allow-multiple-definition to workaround FTBFS on armel/armhf

  [ Ole Streicher ]
  * Push Standards-Version to 4.6.0. No changes needed

 -- Ole Streicher <olebole@debian.org>  Tue, 24 Aug 2021 09:42:09 +0200

gnudatalanguage (1.0.0-3) unstable; urgency=medium

  * Use -fcommon to fix ftbfs on ARM
  * Update failing tests for arm64el

 -- Ole Streicher <olebole@debian.org>  Fri, 20 Aug 2021 14:58:16 +0200

gnudatalanguage (1.0.0-2) unstable; urgency=medium

  * No change re-upload to overcome upload glitch

 -- Ole Streicher <olebole@debian.org>  Thu, 19 Aug 2021 20:58:03 +0200

gnudatalanguage (1.0.0-1) unstable; urgency=medium

  * New upstream version 1.0.0. Closes: #983235
  * Rediff patches
  * Push Standards-Version to 4.5.1. No changes needed
  * Update required plplot driver build dependency
  * Remove unneeded antlr subdirectory
  * Adjust auto_test preparation
  * Fix double-free leading to a crash on Python-GDL shutdown
  * Switch to unstable

 -- Ole Streicher <olebole@debian.org>  Thu, 19 Aug 2021 18:10:42 +0200

gnudatalanguage (1.0.0~rc.3-1) experimental; urgency=low

  * Remove H1_OFFSET2 patch for big endian
  * Remove local PROJ4 support patch
  * Remove disabling specialized alitvec code
  * Add copyright of resource/maps/*/continents.* (LGPL)
  * Recommend wxwidgets driver
  * New upstream version 1.0.0~rc.3
  * Rediff patches
  * Update test procedure. Update local xfail/ignore lists
  * Empty xfail list to see which are working now
  * Remove unneeded dpkg-dev build dependency

 -- Ole Streicher <olebole@debian.org>  Sat, 20 Jun 2020 15:05:21 +0200

gnudatalanguage (1.0.0~rc.2-1) experimental; urgency=low

  * New upstream version 1.0.0~rc.2. Rediff patches. Closes: #961037
  * Push Standards-Version to 4.5.0. No changes needed
  * Push dh-compat to 13
  * Update and shorten d/copyright
  * Remove unneeded minversion for dpkg-dev build dep

 -- Ole Streicher <olebole@debian.org>  Thu, 21 May 2020 10:51:41 +0200

gnudatalanguage (1.0.0~rc.1+dfsg-3) experimental; urgency=low

  * Add missing H1_OFFSET2 for big endian

 -- Ole Streicher <olebole@debian.org>  Mon, 16 Dec 2019 15:58:35 +0100

gnudatalanguage (1.0.0~rc.1+dfsg-2) experimental; urgency=low

  * New upstream version 1.0.0~rc.1+dfsg. Switch to experimental.
  * Rediff patches. Remove patches that were applied upstream
  * Remove suspicious HTML files from resource/maps
  * Update d/watch to use +dfsg and catch the RC version
  * Push Standards-Version to 4.4.1. No changes needed
  * Replace $ADTTMP by $AUTOPKGTEST_TMP in test scripts
  * Update d/copyright

 -- Ole Streicher <olebole@debian.org>  Wed, 04 Dec 2019 11:17:44 +0100

gnudatalanguage (0.9.9-13) unstable; urgency=low

  * Use TI RPC instead of Sun RPC. (Closes: #968737)

 -- Ole Streicher <olebole@debian.org>  Sun, 23 Aug 2020 14:09:01 +0200
