=== debian/rules ===
--- 
+++ 
@@ -11,6 +11,10 @@
 ifneq (,$(filter $(DEB_HOST_ARCH), mips mipsel))
   export CXXFLAGS += -g1
 endif
+
+# Workaround for
+# https://github.com/gnudatalanguage/gdl/issues/677
+LDFLAGS += -Wl,--allow-multiple-definition
 
 %:
 	dh $@ -Scmake --with python3
@@ -34,10 +38,10 @@
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	( cd obj*/testsuite \
-	&& $(CXX) $(CXXFLAGS) -o libtest_ce.so ../../testsuite/libtest_ce.cpp -shared -fPIC \
-	&& $(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -o launchtest ../../testsuite/launchtest.c )
+	&& $(CXX) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) -o libtest_ce.so ../../testsuite/libtest_ce.cpp -shared -fPIC )
 	LD_LIBRARY_PATH="../src" xvfb-run dh_auto_test --no-parallel -Scmake || true
 endif
+
 
 override_dh_compress:
 	dh_compress -X.pro
